function varargout = clustering_hyperplane( varargin)

	vectors = {};
	for i=1:nargin,
		vectors{end+1} = varargin{i};
	end

	w = ( vectors{1} - vectors{2})';
	c = -( vectors{1}'*vectors{1} - vectors{2}'*vectors{2}) / 2;
	fprintf( '\nEquation of the hyperplane is ');
	for i=1:length(w),
		if i==1
			fprintf( '%.3f * x%d', w(i), i);
		else
			if w(i)>=0
				fprintf( ' + %.3f * x%d', abs(w(i)), i);
			else
				fprintf( ' - %.3f * x%d', abs(w(i)), i);
			end
		end
	end
	if c<0
		fprintf( ' - %.3f = 0\n', abs(c));
	else
		fprintf( ' + %.3f = 0\n', c);
	end
	
	d={};
	for i=1:nargin
		d{end+1} = w * vectors{i} + c;
	end;
	if d{1} > 0 
		positive_one = true;
	end;
		
	for i=3:nargin,
		if d{i} > 0
			if positive_one
				fprintf('Pattern #%d computes d(x)=%.3f [d(x)>0] and belongs to the area of reference pattern 1.\n',i,d{i});
			else
				fprintf('Pattern #%d computes d(x)=%.3f [d(x)>0] and belongs to the area of reference pattern 2.\n',i,d{i});
			end
		end
		if d{i} < 0
			if positive_one
				fprintf('Pattern #%d computes d(x)=%.3f [d(x)<0] and belongs to the area of reference pattern 2.\n',i,d{i});
			else
				fprintf('Pattern #%d computes d(x)=%.3f [d(x)<0] and belongs to the area of reference pattern 1.\n',i,d{i});
			end
		end
	end;

	dimensions = length( vectors{1});
	lims = limits(cell2mat(vectors));
	lims(1) = lims(1)-1;
	lims(2) = lims(2)+1;
	if dimensions == 2,
		figure;
		hold on;
		for i=1:nargin
			plot( vectors{i}(1), vectors{i}(2), 'o');
			text( vectors{i}(1)-.2, vectors{i}(2)-.2, sprintf('x%d',i));
		end;
		X1 = lims(1):.1:lims(2);
		X2 = -( c + w(1) * X1 ) / w(2);
		plot( X1,  X2);
		xlabel('x1');
		ylabel('x2');
		hold off;
		axis tight;
		grid on;
		zoom on;
	end
	if dimensions == 3,
		figure;
		hold on;
		for i=1:nargin
			plot3( vectors{i}(1), vectors{i}(2), vectors{i}(3), 'o');
			text( vectors{i}(1)-.2, vectors{i}(2)-.2, vectors{i}(3)-.2, sprintf('x%d',i));
		end;
		X = lims(1):.1:lims(2);
		[X,Y] = meshgrid( X );
		Z = -(c + w(1)*X + w(2)*Y) / w(3);
		surf( X, Y, Z); colormap gray; shading interp;
		axis tight;
		grid on;
		xlabel('x1');
		ylabel('x2');
		zlabel('x3');
		rotate3d on;
	end